diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/__init__.py
index 2105fe210..66fd6be5f 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/__init__.py
@@ -13,6 +13,8 @@ import simplejson as json
 from functools import wraps
 
 import pgadmin.browser.server_groups.servers.databases as database
+import pgadmin.browser.server_groups.servers.databases.schemas.tables.\
+    constraints.foreign_key.utils as fkey_utils
 from flask import render_template, make_response, request, jsonify
 from flask_babelex import gettext as _
 from pgadmin.browser.server_groups.servers.databases.schemas.tables.\
@@ -176,9 +178,6 @@ class ForeignKeyConstraintView(PGChildNodeView):
       - This function is used to return modified SQL for the selected
       foreign key.
 
-    * get_sql()
-      - This function will generate sql from model data.
-
     * sql():
       - This function will generate sql to show it in sql pane for the
       selected foreign key.
@@ -237,16 +236,9 @@ class ForeignKeyConstraintView(PGChildNodeView):
                 self.manager.version)
 
             # We need parent's name eg table name and schema name
-            SQL = render_template("/".join([self.template_path,
-                                            'get_parent.sql']),
-                                  tid=kwargs['tid'])
-            status, rset = self.conn.execute_2darray(SQL)
-            if not status:
-                return internal_server_error(errormsg=rset)
-
-            for row in rset['rows']:
-                self.schema = row['schema']
-                self.table = row['table']
+            schema, table = fkey_utils.get_parent(self.conn, kwargs['tid'])
+            self.schema = schema
+            self.table = table
 
             return f(*args, **kwargs)
         return wrap
@@ -274,51 +266,18 @@ class ForeignKeyConstraintView(PGChildNodeView):
         Returns:
 
         """
-        sql = render_template("/".join([self.template_path, 'properties.sql']),
-                              tid=tid, cid=fkid)
-
-        status, res = self.conn.execute_dict(sql)
-
+        status, res = fkey_utils.get_foreign_keys(self.conn, tid, fkid)
         if not status:
-            return internal_server_error(errormsg=res)
+            return res
 
-        if len(res['rows']) == 0:
+        if len(res) == 0:
             return gone(_(
                 """Could not find the foreign key constraint in the table."""
             ))
 
-        result = res['rows'][0]
-
-        sql = render_template("/".join([self.template_path,
-                                        'get_constraint_cols.sql']),
-                              tid=tid,
-                              keys=zip(result['confkey'], result['conkey']),
-                              confrelid=result['confrelid'])
-
-        status, res = self.conn.execute_dict(sql)
-
-        if not status:
-            return internal_server_error(errormsg=res)
-
-        columns = []
-        cols = []
-        for row in res['rows']:
-            columns.append({"local_column": row['conattname'],
-                            "references": result['confrelid'],
-                            "referenced": row['confattname']})
-            cols.append(row['conattname'])
-
-        result['columns'] = columns
-
+        result = res
         if fkid:
-            coveringindex = self.search_coveringindex(tid, cols)
-            result['coveringindex'] = coveringindex
-            if coveringindex:
-                result['autoindex'] = True
-                result['hasindex'] = True
-            else:
-                result['autoindex'] = False
-                result['hasindex'] = False
+            result = res[0]
 
         return ajax_response(
             response=result,
@@ -373,16 +332,9 @@ class ForeignKeyConstraintView(PGChildNodeView):
             self.manager.version)
 
         # We need parent's name eg table name and schema name
-        SQL = render_template("/".join([self.template_path,
-                                        'get_parent.sql']),
-                              tid=tid)
-        status, rset = self.conn.execute_2darray(SQL)
-        if not status:
-            return internal_server_error(errormsg=rset)
-
-        for row in rset['rows']:
-            self.schema = row['schema']
-            self.table = row['table']
+        schema, table = fkey_utils.get_parent(self.conn, tid)
+        self.schema = schema
+        self.table = table
 
         SQL = render_template("/".join([self.template_path,
                                         'properties.sql']),
@@ -488,16 +440,10 @@ class ForeignKeyConstraintView(PGChildNodeView):
             self.manager.version)
 
         # We need parent's name eg table name and schema name
-        SQL = render_template("/".join([self.template_path,
-                                        'get_parent.sql']),
-                              tid=tid)
-        status, rset = self.conn.execute_2darray(SQL)
-        if not status:
-            return internal_server_error(errormsg=rset)
+        schema, table = fkey_utils.get_parent(self.conn, tid)
+        self.schema = schema
+        self.table = table
 
-        for row in rset['rows']:
-            self.schema = row['schema']
-            self.table = row['table']
         res = []
         SQL = render_template("/".join([self.template_path,
                                         'nodes.sql']),
@@ -575,15 +521,11 @@ class ForeignKeyConstraintView(PGChildNodeView):
         data['schema'] = self.schema
         data['table'] = self.table
         try:
-            SQL = render_template("/".join([self.template_path,
-                                            'get_parent.sql']),
-                                  tid=data['columns'][0]['references'])
-            status, res = self.conn.execute_2darray(SQL)
-            if not status:
-                return internal_server_error(errormsg=res)
-
-            data['remote_schema'] = res['rows'][0]['schema']
-            data['remote_table'] = res['rows'][0]['table']
+            # Get the parent schema and table.
+            schema, table = fkey_utils.get_parent(
+                self.conn, data['columns'][0]['references'])
+            data['remote_schema'] = schema
+            data['remote_table'] = table
 
             if 'name' not in data or data['name'] == "":
                 SQL = render_template(
@@ -690,7 +632,7 @@ class ForeignKeyConstraintView(PGChildNodeView):
         try:
             data['schema'] = self.schema
             data['table'] = self.table
-            sql, name = self.get_sql(data, tid, fkid)
+            sql, name = fkey_utils.get_sql(self.conn, data, tid, fkid)
             if not isinstance(sql, (str, unicode)):
                 return sql
             sql = sql.strip('\n').strip(' ')
@@ -826,7 +768,7 @@ class ForeignKeyConstraintView(PGChildNodeView):
         data['schema'] = self.schema
         data['table'] = self.table
         try:
-            sql, name = self.get_sql(data, tid, fkid)
+            sql, name = fkey_utils.get_sql(self.conn, data, tid, fkid)
             if not isinstance(sql, (str, unicode)):
                 return sql
             sql = sql.strip('\n').strip(' ')
@@ -840,96 +782,6 @@ class ForeignKeyConstraintView(PGChildNodeView):
         except Exception as e:
             return internal_server_error(errormsg=str(e))
 
-    def get_sql(self, data, tid, fkid=None):
-        """
-        This function will generate sql from model data.
-
-        Args:
-          data: Contains the data of the selected foreign key constraint.
-          tid: Table ID.
-          fkid: Foreign key constraint ID
-
-        Returns:
-
-        """
-        if fkid is not None:
-            sql = render_template(
-                "/".join([self.template_path, 'properties.sql']),
-                tid=tid, cid=fkid)
-            status, res = self.conn.execute_dict(sql)
-            if not status:
-                return internal_server_error(errormsg=res)
-            if len(res['rows']) == 0:
-                return gone(_("""Could not find the foreign key."""))
-
-            old_data = res['rows'][0]
-            required_args = ['name']
-            for arg in required_args:
-                if arg not in data:
-                    data[arg] = old_data[arg]
-
-            sql = render_template("/".join([self.template_path, 'update.sql']),
-                                  data=data, o_data=old_data)
-
-            if 'autoindex' in data and data['autoindex'] and \
-                    ('coveringindex' in data and data['coveringindex'] != ''):
-
-                col_sql = render_template(
-                    "/".join([self.template_path, 'get_constraint_cols.sql']),
-                    tid=tid,
-                    keys=zip(old_data['confkey'], old_data['conkey']),
-                    confrelid=old_data['confrelid']
-                )
-
-                status, res = self.conn.execute_dict(col_sql)
-
-                if not status:
-                    return internal_server_error(errormsg=res)
-
-                columns = []
-                for row in res['rows']:
-                    columns.append({"local_column": row['conattname'],
-                                    "references": old_data['confrelid'],
-                                    "referenced": row['confattname']})
-
-                data['columns'] = columns
-
-                sql += render_template(
-                    "/".join([self.template_path, 'create_index.sql']),
-                    data=data, conn=self.conn)
-        else:
-            required_args = ['columns']
-
-            for arg in required_args:
-                if arg not in data:
-                    return _('-- definition incomplete')
-                elif isinstance(data[arg], list) and len(data[arg]) < 1:
-                    return _('-- definition incomplete')
-
-            if data['autoindex'] and \
-                ('coveringindex' not in data or
-                 data['coveringindex'] == ''):
-                return _('-- definition incomplete')
-
-            SQL = render_template("/".join([self.template_path,
-                                            'get_parent.sql']),
-                                  tid=data['columns'][0]['references'])
-            status, rset = self.conn.execute_2darray(SQL)
-            if not status:
-                return internal_server_error(errormsg=rset)
-
-            data['remote_schema'] = rset['rows'][0]['schema']
-            data['remote_table'] = rset['rows'][0]['table']
-
-            sql = render_template("/".join([self.template_path, 'create.sql']),
-                                  data=data, conn=self.conn)
-
-            if data['autoindex']:
-                sql += render_template(
-                    "/".join([self.template_path, 'create_index.sql']),
-                    data=data, conn=self.conn)
-        return sql, data['name'] if 'name' in data else old_data['name']
-
     @check_precondition
     def sql(self, gid, sid, did, scid, tid, fkid=None):
         """
@@ -980,16 +832,11 @@ class ForeignKeyConstraintView(PGChildNodeView):
 
         data['columns'] = columns
 
-        SQL = render_template("/".join([self.template_path,
-                                        'get_parent.sql']),
-                              tid=data['columns'][0]['references'])
-        status, res = self.conn.execute_2darray(SQL)
-
-        if not status:
-            return internal_server_error(errormsg=res)
-
-        data['remote_schema'] = res['rows'][0]['schema']
-        data['remote_table'] = res['rows'][0]['table']
+        # Get the parent schema and table.
+        schema, table = fkey_utils.get_parent(self.conn,
+                                              data['columns'][0]['references'])
+        data['remote_schema'] = schema
+        data['remote_table'] = table
 
         SQL = render_template(
             "/".join([self.template_path, 'create.sql']), data=data)
@@ -1087,46 +934,6 @@ class ForeignKeyConstraintView(PGChildNodeView):
         except Exception as e:
             return internal_server_error(errormsg=str(e))
 
-    def search_coveringindex(self, tid, cols):
-        """
-
-        Args:
-          tid: Table id
-          cols: column list
-
-        Returns:
-
-        """
-
-        cols = set(cols)
-        SQL = render_template("/".join([self.template_path,
-                                        'get_constraints.sql']),
-                              tid=tid)
-        status, constraints = self.conn.execute_dict(SQL)
-
-        if not status:
-            raise Exception(constraints)
-
-        for costrnt in constraints['rows']:
-
-            sql = render_template(
-                "/".join([self.template_path, 'get_cols.sql']),
-                cid=costrnt['oid'],
-                colcnt=costrnt['col_count'])
-            status, rest = self.conn.execute_dict(sql)
-
-            if not status:
-                return internal_server_error(errormsg=rest)
-
-            indexcols = set()
-            for r in rest['rows']:
-                indexcols.add(r['column'].strip('"'))
-
-            if len(cols - indexcols) == len(indexcols - cols) == 0:
-                return costrnt["idxname"]
-
-        return None
-
     @check_precondition
     def get_coveringindex(self, gid, sid, did, scid, tid=None):
         """
@@ -1146,7 +953,7 @@ class ForeignKeyConstraintView(PGChildNodeView):
         try:
             if data and 'cols' in data:
                 cols = set(json.loads(data['cols'], encoding='utf-8'))
-                index = self.search_coveringindex(tid, cols)
+                index = fkey_utils.search_coveringindex(self.conn, tid, cols)
 
             return make_json_response(
                 data=index,
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/utils.py
new file mode 100644
index 000000000..53dab92ac
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/constraints/foreign_key/utils.py
@@ -0,0 +1,292 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2019, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+""" Implements Utility class for Foreign Keys. """
+
+from flask import render_template
+from flask_babelex import gettext as _
+from pgadmin.utils.ajax import internal_server_error
+from pgadmin.utils.exception import ObjectGone
+from functools import wraps
+
+
+def get_template_path(f):
+    """
+    This function will behave as a decorator which will prepare
+    the template path based on database server version.
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold the connection object
+        conn_obj = args[0]
+        template_path = ''
+        if 'template_path' not in kwargs:
+            template_path = 'foreign_key/sql/#{0}#'.format(
+                conn_obj.manager.version)
+        else:
+            template_path = kwargs['template_path']
+
+        return f(*args, **kwargs, template_path=template_path)
+    return wrap
+
+
+@get_template_path
+def get_foreign_keys(conn, tid, fkid=None, template_path=None):
+    """
+    This function is used to fetch information of the
+    foreign key(s) for the given table.
+    :param conn: Connection Object
+    :param tid: Table ID
+    :param fkid: Foreign Key ID
+    :param template_path: Template Path
+    :return:
+    """
+
+    sql = render_template("/".join(
+        [template_path, 'properties.sql']), tid=tid, cid=fkid)
+
+    status, result = conn.execute_dict(sql)
+    if not status:
+        return status, internal_server_error(errormsg=result)
+
+    for fk in result['rows']:
+        sql = render_template("/".join([template_path,
+                                        'get_constraint_cols.sql']),
+                              tid=tid,
+                              keys=zip(fk['confkey'], fk['conkey']),
+                              confrelid=fk['confrelid'])
+
+        status, res = conn.execute_dict(sql)
+        if not status:
+            return status, internal_server_error(errormsg=res)
+
+        columns = []
+        cols = []
+        for row in res['rows']:
+            columns.append({"local_column": row['conattname'],
+                            "references": fk['confrelid'],
+                            "referenced": row['confattname']})
+            cols.append(row['conattname'])
+
+        fk['columns'] = columns
+
+        if not fkid:
+            schema, table = get_parent(conn, fk['columns'][0]['references'])
+            fk['remote_schema'] = schema
+            fk['remote_table'] = table
+
+        coveringindex = search_coveringindex(conn, tid, cols)
+        fk['coveringindex'] = coveringindex
+        if coveringindex:
+            fk['autoindex'] = True
+            fk['hasindex'] = True
+        else:
+            fk['autoindex'] = False
+            fk['hasindex'] = False
+
+    return True, result['rows']
+
+
+@get_template_path
+def search_coveringindex(conn, tid, cols, template_path=None):
+    """
+    This function is used to search the covering index
+    :param conn: Connection Object
+    :param tid: Table id
+    :param cols: Columns
+    :param template_path: Template Path
+    :return:
+    """
+
+    cols = set(cols)
+    SQL = render_template("/".join([template_path,
+                                    'get_constraints.sql']),
+                          tid=tid)
+    status, constraints = conn.execute_dict(SQL)
+    if not status:
+        raise Exception(constraints)
+
+    for constraint in constraints['rows']:
+        sql = render_template(
+            "/".join([template_path, 'get_cols.sql']),
+            cid=constraint['oid'],
+            colcnt=constraint['col_count'])
+        status, rest = conn.execute_dict(sql)
+
+        if not status:
+            raise Exception(rest)
+
+        index_cols = set()
+        for r in rest['rows']:
+            index_cols.add(r['column'].strip('"'))
+
+        if len(cols - index_cols) == len(index_cols - cols) == 0:
+            return constraint["idxname"]
+
+    return None
+
+
+@get_template_path
+def get_parent(conn, tid, template_path=None):
+    """
+    This function will return the parent of the given table.
+    :param conn: Connection Object
+    :param tid: Table oid
+    :param template_path:
+    :return:
+    """
+
+    SQL = render_template("/".join([template_path,
+                                    'get_parent.sql']), tid=tid)
+    status, rset = conn.execute_2darray(SQL)
+    if not status:
+        raise Exception(rset)
+
+    schema = ''
+    table = ''
+    if 'rows' in rset and len(rset['rows']) > 0:
+        schema = rset['rows'][0]['schema']
+        table = rset['rows'][0]['table']
+
+    return schema, table
+
+
+@get_template_path
+def get_foreign_key_sql(conn, tid, data, template_path=None):
+    """
+    This function will return sql for foreign keys.
+    :param conn: Connection Object
+    :param tid: Table ID
+    :param data: Data
+    :param template_path: Template Path
+    :return:
+    """
+
+    sql = []
+    # Check if constraint is in data
+    # If yes then we need to check for add/change/delete
+    if 'foreign_key' in data:
+        constraint = data['foreign_key']
+        # If constraint(s) is/are deleted
+        if 'deleted' in constraint:
+            for c in constraint['deleted']:
+                c['schema'] = data['schema']
+                c['table'] = data['name']
+
+                # Sql for drop
+                sql.append(
+                    render_template("/".join(
+                        [template_path,
+                         'delete.sql']),
+                        data=c, conn=conn).strip('\n')
+                )
+
+        if 'changed' in constraint:
+            for c in constraint['changed']:
+                c['schema'] = data['schema']
+                c['table'] = data['name']
+
+                modified_sql, name = get_sql(conn, c, tid, c['oid'])
+                sql.append(modified_sql.strip("\n"))
+
+        if 'added' in constraint:
+            for c in constraint['added']:
+                c['schema'] = data['schema']
+                c['table'] = data['name']
+
+                add_sql, name = get_sql(conn, c, tid)
+                sql.append(add_sql.strip("\n"))
+
+    if len(sql) > 0:
+        # Join all the sql(s) as single string
+        return '\n\n'.join(sql)
+    else:
+        return None
+
+
+@get_template_path
+def get_sql(conn, data, tid, fkid=None, template_path=None):
+    """
+    This function will generate sql from model data.
+    :param conn: Connection Object
+    :param data: data
+    :param tid: Table id
+    :param fkid: Foreign Key
+    :param template_path: Template Path
+    :return:
+    """
+    name = data['name'] if 'name' in data else None
+    if fkid is not None:
+        sql = render_template("/".join([template_path, 'properties.sql']),
+                              tid=tid, cid=fkid)
+        status, res = conn.execute_dict(sql)
+        if not status:
+            raise Exception(res)
+
+        if len(res['rows']) == 0:
+            raise ObjectGone(
+                _('Could not find the foreign key constraint in the table.'))
+
+        old_data = res['rows'][0]
+        if 'name' not in data:
+            name = data['name'] = old_data['name']
+
+        sql = render_template("/".join([template_path, 'update.sql']),
+                              data=data, o_data=old_data)
+
+        if 'autoindex' in data and data['autoindex'] and \
+                ('coveringindex' in data and data['coveringindex'] != ''):
+            col_sql = render_template(
+                "/".join([template_path, 'get_constraint_cols.sql']),
+                tid=tid,
+                keys=zip(old_data['confkey'], old_data['conkey']),
+                confrelid=old_data['confrelid']
+            )
+
+            status, res = conn.execute_dict(col_sql)
+            if not status:
+                raise Exception(res)
+
+            columns = []
+            for row in res['rows']:
+                columns.append({"local_column": row['conattname'],
+                                "references": old_data['confrelid'],
+                                "referenced": row['confattname']})
+
+            data['columns'] = columns
+
+            sql += render_template(
+                "/".join([template_path, 'create_index.sql']),
+                data=data, conn=conn)
+    else:
+        if 'columns' not in data:
+            return _('-- definition incomplete'), name
+        elif isinstance(data['columns'], list) and len(data['columns']) < 1:
+            return _('-- definition incomplete'), name
+
+        if data['autoindex'] and \
+                ('coveringindex' not in data or data['coveringindex'] == ''):
+            return _('-- definition incomplete'), name
+
+        # Get the parent schema and table.
+        schema, table = get_parent(conn,
+                                   data['columns'][0]['references'])
+        data['remote_schema'] = schema
+        data['remote_table'] = table
+
+        sql = render_template("/".join([template_path, 'create.sql']),
+                              data=data, conn=conn)
+
+        if data['autoindex']:
+            sql += render_template(
+                "/".join([template_path, 'create_index.sql']),
+                data=data, conn=conn)
+
+    return sql, name
